Attribute VB_Name = "Module1"
Option Explicit
'
'Creates new MDB, loads a CSV file as a table, etc.
'

Private Const CSVNAME As String = "USPresidents.csv"
Private Const MDBNAME As String = "USPresidents.mdb"
Private Const PROVIDERSTRING As String = _
    "Provider=Microsoft.Jet.OLEDB.4.0;Jet OLEDB:Engine Type=5;Data Source='$MDB$'"

Private Sub Main()
    Dim catDB As Object 'As ADOX.Catalog.
    Dim cnDB As ADODB.Connection
    
    ChDir App.Path
    ChDrive App.Path
    On Error Resume Next
    Kill MDBNAME
    On Error GoTo 0
    Set catDB = CreateObject("ADOX.Catalog")
    With catDB
        .Create Replace$(PROVIDERSTRING, "$MDB$", App.Path & "\" & MDBNAME)
        Set cnDB = .ActiveConnection
    End With
    Set catDB = Nothing
    With cnDB
        .Execute "SELECT * INTO [Presidents] FROM [Text;Database=" _
               & App.Path & ";HDR=Yes].[" & CSVNAME & "]", , adCmdText
        .Execute "ALTER TABLE [Presidents] DROP COLUMN [Portrait]", , adCmdText
        .Execute "ALTER TABLE [Presidents] DROP COLUMN [Thumbnail]", , adCmdText
        .Execute "CREATE INDEX [idxPresidency] ON [Presidents] ([Presidency]) " _
               & "WITH PRIMARY", , adCmdText
        .Execute "CREATE INDEX [idxHomeState] ON [Presidents] ([Home State])", , adCmdText
        .Execute "SELECT DISTINCT [Home State] INTO [HomeStates] " _
               & "FROM [Presidents] ORDER BY [Home State]", , adCmdText
        .Execute "CREATE INDEX [idxHomeState] ON [HomeStates] ([Home State]) " _
               & "WITH PRIMARY", , adCmdText
        cnDB.Close
    End With
    
    MsgBox "Database created, data imported and indexed."
End Sub

